install.packages("arules")
install.packages("ggplot2")
library(arules)
library(ggplot2)
Data<-read.csv("BMI PAPER DATA.csv")
head(Data)
str(Data)
#Creating transactions for arules package
binary_data <- Data[, c(3:8)]
binary_data[] <- lapply(binary_data, as.logical)
transactions <- as(binary_data, "transactions")
summary(transactions)
rules <- apriori(transactions, parameter = list(support = 0.01, confidence = 1))
#Removing Lift as it does not apply to our analysis due to having only positive ticks 
rule_quality <- quality(rules)
rule_quality <- rule_quality[, !colnames(rule_quality) %in% "lift"]
quality(rules) <- rule_quality
inspect(rules)
# Extract rules where BMI is in the right-hand side (RHS) only
bmi_rhs_rules <- subset(rules, rhs %pin% "BMI")
# Inspect the filtered rules
inspect(bmi_rhs_rules)
# Sort rules by support and inspect again
inspect(sort(bmi_rhs_rules, by = "support"))
# Convert filtered rules to a data frame for plotting
bmi_rhs_rule_data <- as(bmi_rhs_rules, "data.frame")
# Remove BMI -> BMI
bmi_rhs_rules_filtered <- subset(bmi_rhs_rules, 
                                 !(labels(lhs(bmi_rhs_rules)) == "{}" & labels(rhs(bmi_rhs_rules)) == "{BMI}"))
# Convert the filtered rules to a data frame for plotting
bmi_rhs_rule_data <- as(bmi_rhs_rules_filtered, "data.frame")
# Plot after removing only BMI -> BMI
ggplot(bmi_rhs_rule_data, aes(x = reorder(rules, -support), y = support, fill = confidence)) +
  geom_bar(stat = "identity") +
  coord_flip() +
  labs(title = "Support of Association Rules with BMI on the RHS (Filtered)",
       x = "Rules",
       y = "Support") +
  scale_fill_gradient(low = "blue", high = "violet", name = "Confidence") +
  ylim(0,1)+
  theme_minimal()
